<template>
  <div>
    <q-dialog
      v-model="showCaseCreation"
    >
      <q-card style="width: 700px; max-width: 80vw; padding: 10px">
        <q-form
          id="case-creation-form"
          @submit="createCase"
          @reset="resetCaseCreation"
        >
          <div class="text-h5 col q-pa-sm">
            Create Case
          </div>
          <q-input
            v-model="localCaseId"
            outlined
            label="ID"
            class="col q-pa-sm"
            style="margin-bottom: 15px"
            lazy-rules
            :rules="[ val => val && val.length > 0 || 'Please add ID.',
                      val => val && val.length < 50 || 'Please shorten the ID.',
                      val => checkLocalCaseId(val) || 'Please change ID. ID already exists.',]"
          />
          <q-input
            v-model="description"
            outlined
            label="Description"
            class="col q-pa-sm"
            style="margin-bottom: 15px"
            lazy-rules
            :rules="[ val => val && val.length > 0 || 'Please add a description.',]"
          />
          <q-btn
            class="q-ma-sm"
            outline
            label="Create Case"
            type="submit"
          />
          <q-btn
            class="q-ma-sm"
            outline
            label="Cancel"
            @click="showCaseCreation=false"
          />
        </q-form>
      </q-card>
    </q-dialog>
    <case-agreement
      ref="caseAgreement"
      @accepted="acceptedAgreement"
    />
  </div>
</template>

<script>
import idm from '../../mixins/idm_api'
import mds from '../../mixins/mds_api'
import CaseAgreement from './CaseAgreement.vue'

export default {
  name: 'CaseCreation',
  components: {
    caseAgreement: CaseAgreement
  },
  props: {
    creatorId: {
      type: String,
      default: 'default_user'
    },
    existingLocalIds: {
      type: Array,
      default: f => { return {} }
    }
  },
  data () {
    return {
      showCaseCreation: false,
      localCaseId: null,
      description: null
    }
  },
  watch: {
    showCaseCreation: function () {
      if (this.showCaseCreation) {
        this.resetCaseCreation()
      }
    }
  },
  methods: {
    async createCase (accepted = false) {
      if (!localStorage.getItem('casesAgreement') && accepted !== true) {
        this.$refs.caseAgreement.agreement = true
        return
      }
      const caseResponse = await mds.createCase(this.creatorId, this.description)
      await idm.addCaseIdMapping(
        caseResponse.id,
        this.localCaseId
      )
      this.$emit('created', caseResponse.id)
    },
    acceptedAgreement () {
      this.createCase(true)
    },
    resetCaseCreation () {
      this.localCaseId = null
      this.description = null
    },
    checkLocalCaseId (localCaseId) {
      return this.existingLocalIds.filter(e => e.label === localCaseId).length === 0
    }
  }
}
</script>
